/**
 * 初始化人才认定申报详情对话框
 */
var locked = false;
var TalentInfoInfoDlg = {
    talentInfoInfoData: {},
    validateFields1: {
        phone: {
            validators: {
                regexp: {
                    regexp: /0?(13|14|15|16|17|18|19)[0-9]{9}/,
                    message: "手机号码格式不正确"
                }
            }
        },
        email: {
            validators: {
                emailAddress: {
                    message: "电子邮箱格式不正确"
                }
            }
        },
        bank: {
            validators: {
                regexp: {
                    regexp: /^[\u4e00-\u9fa5]*银行$/,
                    message: "开户银行格式不正确"
                }
            }
        }
    },
    validateFields2: {
        enterpriseId: {validators: {notEmpty: {message: '所属医院不能为空'}}},
        type: {validators: {notEmpty: {message: '人才类别不能为空'}}},
        name: {validators: {notEmpty: {message: '姓名不能为空'}}},
        sex: {validators: {notEmpty: {message: '性别不能为空'}}},
        nation: {validators: {notEmpty: {message: '民族不能为空'}}},
        politics: {validators: {notEmpty: {message: '政治面貌不能为空'}}},
        card_type: {validators: {notEmpty: {message: '证件类型不能为空'}}},
        card_number: {validators: {notEmpty: {message: '证件号码不能为空'}}},
        birthday: {validators: {notEmpty: {message: '出生日期不能为空'}}},
        talent_type: {validators: {notEmpty: {message: '人才类型不能为空'}}},
        highest_degree: {validators: {notEmpty: {message: '最高学历不能为空'}}},
        graduate_school: {validators: {notEmpty: {message: '毕业学校不能为空'}}},
        major: {validators: {notEmpty: {message: '专业不能为空'}}},
        position: {validators: {notEmpty: {message: '职务不能为空'}}},
        cur_entry_time: {validators: {notEmpty: {message: '入职时间不能为空'}}},
        labor_contract_rangetime: {validators: {notEmpty: {message: '工作合同时间不能为空'}}},
        talent_arrange: {validators: {notEmpty: {message: '人才层次不能为空'}}},
        talent_arrange_category: {validators: {notEmpty: {message: '人才条款不能为空'}}},
        talent_condition: {validators: {notEmpty: {message: '认定条件不能为空'}}},
        phone: {
            validators: {
                regexp: {
                    regexp: /0?(13|14|15|16|17|18|19)[0-9]{9}/,
                    message: "手机号码格式不正确"
                }
            }
        },
        email: {
            validators: {
                emailAddress: {
                    message: "电子邮箱格式不正确"
                }
            }
        },
        bank: {
            validators: {
                notEmpty: {
                    message: '开户银行不能为空'
                },
                regexp: {
                    regexp: /^[\u4e00-\u9fa5]*银行$/,
                    message: "开户银行格式不正确"
                }
            }
        },
        bank_account: {validators: {notEmpty: {message: '银行账号不能为空'}}},
        bank_number: {validators: {notEmpty: {message: '银行行号不能为空'}}},
        bank_branch_name: {
            validators: {
                notEmpty: {
                    message: '开户银行网点不能为空'
                }
            }
        },
    }
};

/**
 * 清除数据
 */
TalentInfoInfoDlg.clearData = function () {
    this.talentInfoInfoData = {};
}

/**
 * 设置对话框中的数据
 *
 * @param key 数据的名称
 * @param val 数据的具体值
 */
TalentInfoInfoDlg.set = function (key, val) {
    var dis = $("#" + key).attr("disabled");
    if (dis == "disabled") {
        $("#" + key).removeAttr("disabled");
    }
    this.talentInfoInfoData[key] = (typeof val == "undefined") ? $("#" + key).val() : val;
    if (dis == "disabled") {
        $("#" + key).prop("disabled", true);
    }
    return this;
}

/**
 * 设置对话框中的数据
 *
 * @param key 数据的名称
 * @param val 数据的具体值
 */
TalentInfoInfoDlg.get = function (key) {
    return $("#" + key).val();
}

/**
 * 关闭此对话框
 */
TalentInfoInfoDlg.close = function () {
    parent.layer.close(window.parent.TalentInfo.layerIndex);
}

/**
 * 收集数据
 */
TalentInfoInfoDlg.collectData = function () {
    this

            .set('id')
            .set('enterprise_id')
            .set('type')
            .set('card_number')
            .set('card_type')
            .set('name')
            .set('sex')
            .set('nation')
            .set('nationality')
            .set('province')
            .set('city')
            .set('county')
            .set('birthday')
            .set('address')
            .set('politics')
            .set('highest_degree')
            .set('graduate_school')
            .set('major')
            .set('position')
            .set('phone')
            .set('email')
            .set('bank')
            .set('bank_branch_name')
            .set('bank_account')
            .set('bank_number')
            .set('cur_entry_time')
            .set('labor_contract_rangetime')
            .set('is_fujian_talent')
            .set('is_jinjiang_talent')
            .set('talent_arrange')
            .set('talent_condition')
            .set('identifyGetTime')
            .set('identifyConditionName')
            .set('breakFaith')
            .set('education')
            .set('experience')
            .set('industryField')
            .set('title')
            .set('pro_qua')
            .set('study_abroad')
            .set('studyAbroadCountry')
            .set('studyAbroadTime')
            .set('description');
}

/**
 * 验证数据
 */
TalentInfoInfoDlg.validate = function () {
    $('#talentInfoForm').data("bootstrapValidator").resetForm();
    $('#talentInfoForm').bootstrapValidator('validate');
    return $("#talentInfoForm").data('bootstrapValidator').isValid();
}
/**
 * 初始化表格的列
 */
TalentInfoInfoDlg.initFileTypeColumn = function () {
    return [
        {field: 'selectItem', checkbox: false, visible: false},
        {title: '名称', field: 'name', visible: true, align: 'left', valign: 'middle', width: "70%", 'class': 'uitd_showTip',
            formatter: function (value, row, index) {
                let str = '<div class="word-wrap">';
                let highlights_by_api = ["crz"];
                let description = row.description == null ? "" : row.description;
                if (highlights_by_api.indexOf(row.api) > -1) {
                    value = '<span style="font-weight:bold;color:red;">' + value + '</span>';
                    description = '<span style="font-weight:bold;color:red;">' + description + '</span>';
                }
                if (row.must == 1) {
                    str = str + '<i class="fa fa-paste"></i><span style="font-weight:bold;color:red;font-size:14px;font-family:宋体"> * </span> ' + value;
                }
                if (row.must == 2) {
                    str = str + '<i class="fa fa-paste"></i>' + value;
                }
                str = str + '<br /><span id="desc_' + row.rel + '">' + description + '</span></div>'
                return str;
            }
        },
        {title: '模板', field: 'templateUrl', visible: true, align: 'center', valign: 'middle', width: "10%",
            formatter: function (value, row, index) {
                if (value == null || value == '' || value == 'null') {
                    return '无';
                }
                return "<button type='button' onclick=\"TalentInfoInfoDlg.downloadFile('" + row.id + "',5)\" style='margin-right: 10px' class=\"btn btn-xs btn-primary\">" +
                        "<i class=\"fa fa-download\"></i>下载" +
                        "</button>";
            }
        },
        {title: '操作', field: 'id', visible: true, align: 'center', valign: 'middle', width: "20%",
            formatter: function (value, row, index) {
                return TalentInfoInfoDlg.validUploadButton(1, value, '', row.tableIndex, row.trIndex);
            }
        }
    ]
};

TalentInfoInfoDlg.initFileTable = function () {
    var ajax = new $ax("/common/api/findCommonFileType", function (data) {
        if (data == null || data.length == 0) {
            return;
        }
        var datas = new Array();
        for (var i = 0; i < $(".fileTable").length; i++) {
            datas.push([]);//创建空的多维数组，等下用来存每个附件表的各自的列
        }
        var enterpriseTag = $("#enterprise_tag").val();
        for (var k in data["rows"]) {
            if (data["rows"][k].enterprise_tag != "" && data["rows"][k].enterprise_tag != null && data["rows"][k].enterprise_tag.indexOf(enterpriseTag) == -1) {
                continue;
            }
            var rel = data["rows"][k].rel;
            if ($("#" + rel).length > 0) {
                var tableIndex = 0;
                if ($("#" + rel).parents(".table").length > 0) {
                    tableIndex = $("#" + rel).parents(".table").find("table.fileTable").index(".fileTable");
                } else {
                    tableIndex = $("#" + rel).parents(".row").next(".row").find("table.fileTable").index(".fileTable");
                }
                data["rows"][k].tableIndex = tableIndex;
                data["rows"][k].trIndex = datas[tableIndex].length;
                datas[tableIndex].push(data["rows"][k]);
                if (data["rows"][k].option) {
                    //指定了选项
                    if (rel == "birthday") {
                        let age = 0;
                        if ($("#" + rel).val()) {
                            let birthDate = new Date($("#" + rel).val());//生日日期
                            let birthYear = birthDate.getFullYear();
                            let birthMonth = birthDate.getMonth() + 1;
                            let currentDate = new Date();//当前日期
                            let currentYear = currentDate.getFullYear();
                            let currentMonth = currentDate.getMonth() + 1;
                            age = (currentYear * 12 + currentMonth - birthYear * 12 - birthMonth) / 12;
                        }
                        if (age < data["rows"][k].option)
                            data["rows"][k].hidden = true;
                    } else {
                        let selectVal = $("#" + rel).data("value").toString();
                        let options = data["rows"][k].option.split(",");
                        if (options.indexOf(selectVal) == -1) {
                            data["rows"][k].hidden = true;
                        }
                    }
                }
            } else {
                if (data["rows"][k].isConditionFile) {
                    var tableIndex = 0;
                    if ($("#talent_condition").parents(".table").length > 0) {
                        tableIndex = $("#talent_condition").parents(".table").find("table.fileTable").index(".fileTable");
                    } else {
                        tableIndex = $("#talent_condition").parents(".row").next(".row").find("table.fileTable").index(".fileTable");
                    }
                    data["rows"][k].tableIndex = tableIndex;
                    data["rows"][k].trIndex = datas[tableIndex].length;
                    datas[tableIndex].push(data["rows"][k]);//放入人才条件后面的附件表
                } else {
                    var tableIndex = $(".fileTable").length - 2;
                    data["rows"][k].tableIndex = tableIndex;
                    data["rows"][k].trIndex = datas[tableIndex].length;
                    datas[$(".fileTable").length - 2].push(data["rows"][k]);//没有归属，放入最后一个附件表
                }
            }
        }
        for (var i = 0; i < $(".fileTable").length; i++) {
            var that = $(".fileTable").eq(i);
            that.bootstrapTable({
                columns: TalentInfoInfoDlg.initFileTypeColumn(),
                data: datas[i],
                showHeader: false,
                rowStyle: function (row, index) {
                    return {classes: ""};
                },
                onPostBody: function (data) {
                    for (var k in data) {
                        var files = data[k].files;
                        var html = '<ul class="imgs"><li style="width: 70%;font-weight: bold;padding-top: 5px;">附件原名</li><li style="width: 10%;font-weight: bold;padding-top: 5px;">预览</li><li style="width: 20%;font-weight: bold;padding-top: 5px;">操作</li>';
                        for (var key in files) {
                            var btn = "";
                            btn = TalentInfoInfoDlg.validUploadButton(2, data[k].id, files[key].id, i, k);
                            var sn = files[key].url.lastIndexOf(".");
                            var suffix = files[key].ext;//files[key].url.substring(sn + 1, files[key].url.length);
                            var imgStr = "";
                            if (suffix == "pdf" || suffix == "PDF") {
                                imgStr = "<button type='button'  onclick=\"Feng.showPdf('" + files[key].url + "','" + files[key].id + "','" + files[key].orignName + "')\" class=\"btn btn-xs btn-danger\"><i class=\"fa fa-file-pdf-o\" aria-hidden=\"true\"></i></button>";
                            } else if (suffix == "xlsx" || suffix == "XLSX" || suffix == 'xls' || suffix == 'XLS' || suffix == 'docx' || suffix == 'doc' || suffix == 'DOCX' || suffix == 'DOC') {
                                imgStr = "<button type='button'  onclick=\"Feng.showExcel('" + files[key].url + "','" + files[key].id + "','" + files[key].orignName + "')\" class=\"btn btn-xs btn-danger\"><i class=\"fa fa-file-excel-o\" aria-hidden=\"true\"></i></button>";
                            } else {
                                imgStr = '<img class=\"imgUrl\" onclick=\"Feng.showImg(this)\" src=\"' + files[key].url + '\" style=\"width:25px;height:25px;\">';
                            }

                            html += '<li data-id="' + files[key].id + '">\n\
                                    <div>' + (data[k].step != 1 ? '<input type="hidden" name="uploadFiles[]" value="' + files[key].id + '">' : "") + '</div>\n' +
                                    '<div style="width: 70%;">' + files[key].orignName + '</div>\n' +
                                    '<div style="width: 10%;">' + imgStr + '</div>\n' +
                                    '<div style="width: 20%;">' + btn + '</div>\n\
                                    </li>';
                        }
                        html = html + '</ul>';
                        that.find("tr[data-index='" + k + "']").attr("data-rel", data[k]["rel"]);
                        that.find("tr[data-index='" + k + "']").attr("data-option", data[k]["option"]);
                        that.find("tr[data-index='" + k + "']").after('<tr class="detail-view"><td colspan="5">' + html + '</td></tr>');
                        if (typeof data[k].hidden != "undefined") {
                            that.find("tr[data-index='" + k + "']").css("display", "none");
                            that.find("tr[data-index='" + k + "']").next("tr.detail-view").css("display", "none");
                        }
                    }
                    $("td.uitd_showTip").bind("mouseover", function () {
                        var htm = $(this).html();
                        $(this).webuiPopover({title: '详情', content: htm, trigger: 'hover'}).webuiPopover('show');
                    });
                },
            });
        }
    }, function (data) {
        Feng.error("查询失败!" + data.responseJSON.message + "!");
    });
    var queryData = {};
    queryData["mainId"] = $("#id").val();
    queryData['project'] = CONFIG.project_rcrd;
    queryData["source"] = $("#source").val();
    queryData['type'] = $("#type").val();
    queryData["talent_condition"] = $("#talent_condition option:selected").val();
    queryData['checkState'] = $("#checkState").val();
    queryData['isMix'] = 1;
    ajax.set(queryData);
    ajax.start();
}

/**
 * 提交添加
 */
TalentInfoInfoDlg.addSubmit = function () {
    this.clearData();
    this.collectData();
    if (!TalentInfoInfoDlg.validate()) {
        return;
    }
    var id = $('#id').val();
    var name = $("#name").val().trim();
    var cardNumber = $("#card_number").val().trim();
    if (name == "" || cardNumber == "") {
        layer.alert("姓名和证件号码不能为空");
        return;
    }
    if (id != null && id != '') {
        if (!TalentInfoInfoDlg.validateIsEdit())
            return;
    }
    $("select").each(function () {
        $(this).removeAttr("disabled");
    });
    if (locked) {
        return;
    }
    locked = true;
    $("#talentInfoForm").attr("action", "/enterprise/talent/apply");
    $("#talentInfoForm")[0].submit();
}

//回调
TalentInfoInfoDlg.infoCallback = function (data) {
    locked = false;
    TalentInfoInfoDlg.setNoChangeField();
    Feng.info(data.msg);
    if (data.code == 200) {
        window.parent.TalentInfo.table.refresh();
        $("#id").val(data.obj.id);
        $("#fileLi").removeAttr("style");
        $("#checkState").val(data.obj.checkState);
    }
    return;
}
/**
 * 获取人才认定
 */
TalentInfoInfoDlg.getIdentifyCondition = function () {
    $("#talent_condition").parents(".table").find(".fileTable").find("tbody").html("");

    $('#talentInfoForm').bootstrapValidator('removeField', "annual_salary");
    var level = $("#talent_arrange").val();
    var id = $('#id').val();
    Feng.addAjaxSelect({
        "id": "talent_condition",
        "displayCode": "id",
        "displayName": "name",
        "type": "GET",
        "url": Feng.ctxPath + "/common/api/findIdentifyConditionByLevel/level/" + level + "/id/" + id
    });
    $("#talent_condition").trigger('chosen:updated');
}

TalentInfoInfoDlg.getIdentifyNeedsFileTypes = function () {
    $("#talent_condition").parents(".table").find(".fileTable").find("tbody").html("");
    TalentInfoInfoDlg.ajaxGetConditionFile();
}
TalentInfoInfoDlg.ajaxGetConditionFile = function (source) {
    var condition = $("#talent_condition option:selected").val();
    if (condition != "") {
        var ajax = new $ax("/common/api/getTalentCondtionUploadFile", function (data) {
            if (data == null || data.length == 0) {
                return;
            }
            var conditionFileTable = $("#talent_condition").parents(".table").find(".fileTable");
            var tableIndex = conditionFileTable.index(".fileTable");
            var tbody = conditionFileTable.find("tbody");
            var html = "";
            for (var key in data.rows) {
                var filetype = data.rows[key];
                var name = "";
                if (filetype.must == 1) {
                    name = '<i class="fa fa-paste"></i><span style="font-weight:bold;color:red;font-size:14px;font-family:宋体"> * </span> ' + filetype.name;
                }
                if (filetype.must == 2) {
                    name = '<i class="fa fa-paste"></i>' + filetype.name;
                }
                var uploadbtn = TalentInfoInfoDlg.validUploadButton(1, filetype.id, '', tableIndex, key, true);
                var templateUrl = '<button type="button" onclick="TalentInfoInfoDlg.downloadFile("' + filetype.id + '",5)" style="margin-right: 10px" class="btn btn-xs btn-primary">\n\
<i class=\"fa fa-download\"></i>下载""</button>"';
                html += '<tr data-index="' + key + '">\n\
                                <td class="uitd_showTip" style="text-align: center; vertical-align: middle; width: 70%; ">' + name + '<br />' + (filetype.description == null ? "" : filetype.description) + '</td> \n\
                                <td style="text-align: center; vertical-align: middle; width: 10%; ">' + (filetype.templateUrl ? templateUrl : "无") + '</td> \n\
                                <td style="text-align: center; vertical-align: middle; width: 20%; ">' + uploadbtn + '</td> </tr></tr>';
                html += '<tr class="detail-view"><td colspan="5"><ul class="imgs"><li style="width: 70%;font-weight: bold;padding-top: 5px;">附件原名</li><li style="width: 10%;font-weight: bold;padding-top: 5px;">预览</li><li style="width: 20%;font-weight: bold;padding-top: 5px;">操作</li>';

                for (var k in filetype.files) {
                    var file = filetype.files[k];
                    var btn = TalentInfoInfoDlg.validUploadButton(2, filetype.id, file.id, tableIndex, key, true);
                    var sn = file.url.lastIndexOf(".");
                    var suffix = file.ext;//file.url.substring(sn + 1, file.url.length);
                    var imgStr = "";
                    if (suffix == "pdf" || suffix == "PDF") {
                        imgStr = "<button type='button'  onclick=\"Feng.showPdf('" + file.url + "','" + file.id + "','" + file.orignName + "')\" class=\"btn btn-xs btn-danger\"><i class=\"fa fa-file-pdf-o\" aria-hidden=\"true\"></i></button>";
                    } else if (suffix == "xlsx" || suffix == "XLSX" || suffix == 'xls' || suffix == 'XLS' || suffix == 'docx' || suffix == 'doc' || suffix == 'DOCX' || suffix == 'DOC') {
                        imgStr = "<button type='button'  onclick=\"Feng.showExcel('" + file.url + "','" + file.id + "','" + file.orignName + "')\" class=\"btn btn-xs btn-danger\"><i class=\"fa fa-file-excel-o\" aria-hidden=\"true\"></i></button>";
                    } else {
                        imgStr = '<img class=\"imgUrl\"  onclick=\"Feng.showImg(this)\" src=\"' + file.url + '\" style=\"width:25px;height:25px;\">';
                    }

                    html += '<li data-id="' + file.id + '">\n\
                                    <div>' + (filetype.step != 1 ? '<input type="hidden" name="uploadFiles[]" value="' + file.id + '">' : "") + '</div>\n' +
                            '<div style="width: 80%;">' + file.orignName + '</div>\n' +
                            '<div style="width: 10%;">' + imgStr + '</div>\n' +
                            '<div style="width: 10%;">' + btn + '</div>\n\
                                    </li>';
                }
                html += '</ul></td></tr>';
            }
            tbody.html(html);
        }, function (data) {
            Feng.error("查询失败!" + data.responseJSON.message + "!");
        });
        var queryData = {};
        queryData["mainId"] = $("#id").val();
        queryData['project'] = CONFIG.project_rcrd;
        queryData["source"] = source;
        queryData['type'] = $("#type").val();
        queryData["talent_condition"] = condition;
        ajax.set(queryData);
        ajax.start();
    }
}

TalentInfoInfoDlg.onTalentRuleChange = function(){
    var is_fujian_talent = $("#is_fujian_talent").val();
    var is_jinjiang_talent = $("#is_jinjiang_talent").val();
    if(is_fujian_talent == 1 && is_jinjiang_talent == 2){
        
    }
}

TalentInfoInfoDlg.bankChange = function () {
    var bank = $("#bank").val();
    if ($.trim(bank) == '中国工商银行') {
        $("#bank_number").val('102391050013');
    } else {
        $("#bank_number").val('');
    }
}

TalentInfoInfoDlg.changeStudyAbroad = function () {
    var is_abroad = $("#study_abroad").val();
    if (is_abroad == 1) {
        $("#abroad_school").parents("td").css("display", "table-cell");
        $("#abroad_major").parents("td").css("display", "table-cell");
        //$('#talentInfoForm').bootstrapValidator('addField', "abroad_school", {validators: {notEmpty: {message: '留学毕业院校不能为空'}}});
        //$('#talentInfoForm').bootstrapValidator('addField', "abroad_major", {validators: {notEmpty: {message: '留学专业不能为空'}}});
        //$("[data-rel='study_abroad']").find("i.fa-paste").after('<span style="font-weight:bold;color:red;font-size:14px;font-family:宋体"> * </span>');
    } else {
        $("#abroad_school").val("").parents("td").css("display", "none");
        $("#abroad_major").val("").parents("td").css("display", "none");
        //$('#talentInfoForm').bootstrapValidator('removeField', "abroad_school");
        //$('#talentInfoForm').bootstrapValidator('removeField', "abroad_major");
        //$("[data-rel='study_abroad']").find("i.fa-paste").next("span").remove();
    }
}
/**
 * 加载市
 */
TalentInfoInfoDlg.afterSelectProvince = function () {
    var province = $("#province").val();
    $("#city").empty();
    $("#county").empty();
    if (province == null || province == '') {
        return;
    }
    Feng.addAjaxSelect({
        "id": "city",
        "displayCode": "code",
        "displayName": "name",
        "type": "GET",
        "url": Feng.ctxPath + "/common/tool/findCityByProvinceSelect/code/" + province
    });
}
/**
 * 加载县
 */
TalentInfoInfoDlg.afterSelectCity = function () {
    var city = $("#city").val();
    $("#county").empty();
    if (city == null || city == '') {
        return;
    }
    Feng.addAjaxSelect({
        "id": "county",
        "displayCode": "code",
        "displayName": "name",
        "type": "GET",
        "url": Feng.ctxPath + "/common/tool/findCountyByCitySelect/code/" + city
    });
}

TalentInfoInfoDlg.isAgeChecked = false;
TalentInfoInfoDlg.birthdayChange = function () {
    let age = 18;
    if ($("#birthday").val()) {
        let birthDate = new Date($("#birthday").val());//生日日期
        let birthYear = birthDate.getFullYear();
        let birthMonth = birthDate.getMonth() + 1;
        let currentDate = new Date();//当前日期
        let currentYear = currentDate.getFullYear();
        let currentMonth = currentDate.getMonth() + 1;
        age = (currentYear * 12 + currentMonth - birthYear * 12 - birthMonth) / 12;
    }
    /*let birthday = parseInt($("#birthday").val().substring(0, 4));
     let currentYear = parseInt(new Date().getFullYear());
     let age = currentYear - (isNaN(birthday) ? 0 : birthday);*/
    let option = $("[data-rel=birthday]");
    let limitAge = option.data("option");
    if (age >= limitAge) {
        option.css("display", "table-row");
        option.next("tr.detail-view").css("display", "table-row");
        if (!TalentInfoInfoDlg.isAgeChecked) {
            layer.alert("由于您的年龄大于70岁（含），要求提供人社局的允许申报的批文，请线下前往人社局办理。如已办理，请将该批文作为附件上传至对应附件栏中。");
            TalentInfoInfoDlg.isAgeChecked = true;
            return false;
        }
    } else {
        TalentInfoInfoDlg.isAgeChecked = false;
        option.css("display", "none");
        option.next("tr.detail-view").css("display", "none");
    }
    return true;
}
TalentInfoInfoDlg.initBirthday = function () {
    let birthday = parseInt($("#birthday").val().substring(0, 4));
    let currentYear = parseInt(new Date().getFullYear());
    let age = currentYear - (isNaN(birthday) ? 0 : birthday);
    let option = $("[data-rel=birthday]");
    let isFileExists = option.next("tr.detail-view").find("ul.imgs").find("li").length > 3 ? true : false;
    let limitAge = option.data("option");
    if (!isNaN(birthday)) {
        if (age >= limitAge && isFileExists) {
            TalentInfoInfoDlg.isAgeChecked = true;
        }
        TalentInfoInfoDlg.birthdayChange();
    }
}

//校验是否保存基础信息
TalentInfoInfoDlg.validId = function () {
    var id = $("#id").val();
    if (id != null && id != '') {
        $("#fileLi").removeAttr("style");
    } else {
        $("#fileLi").attr("style", "pointer-events: none");
    }
}
//选择附件并显示附件名
TalentInfoInfoDlg.checkFile = function (content, fileTypeId, fileId, tableIndex, trIndex) {
    if (!TalentInfoInfoDlg.validateIsEdit())
        return;
    $("#upload_file").unbind("change");
    $("#upload_file").change(function () {
        if (!Feng.chkFileInvalid(this.files[0], 5, 10))
            return;
        TalentInfoInfoDlg.upload(fileTypeId, fileId, tableIndex, trIndex);
    });
    $('#upload_file').val("");
    $('#upload_file').click();
}
//上传附件
TalentInfoInfoDlg.upload = function (fileTypeId, fileId, tableIndex, trIndex) {
    var id = $("#id").val();
    if (!TalentInfoInfoDlg.validateIsEdit())
        return;
    if (fileId != null && fileId != 'null') {
        $("#fileId").val(fileId)
    } else {
        $("#fileId").val("");
    }
    $("#mainId").val(id);
    $("#fileTypeId").val(fileTypeId);
    $("#tableIndex").val(tableIndex);
    $("#trIndex").val(trIndex);
    var index = layer.load(0, {shade: false, time: 0});
    $("#index").val(index);
    $("#uploadForm").submit();
}
//删除附件
TalentInfoInfoDlg.deleteFile = function (id, obj) {
    if (!TalentInfoInfoDlg.validateIsEdit())
        return;
    var operation = function () {
        var ajax = new $ax(Feng.ctxPath + "/common/api/deleteFile", function (data) {
            if (data.code == 200) {
                Feng.success(data.msg);
                $(obj).parents("li").remove();
                //$("#fileTable").bootstrapTable("refresh", {});
            } else {
                Feng.error(data.msg);
            }
        }, function (data) {
            Feng.error("删除失败!" + data.responseJSON.message + "!");
        });
        ajax.set("id", id);
        ajax.set("type", 1);
        ajax.start();
    }
    Feng.confirm("删除后无法恢复，确认删除吗?", operation);
}

/**
 * 提交审核
 */
TalentInfoInfoDlg.submitToCheck = function () {
    Feng.initValidatorTip("talentInfoForm", TalentInfoInfoDlg.validateFields2);
    var id = $("#id").val();
    if (id == null || id == "") {
        Feng.info("请先填写基础信息并上传附件");
        return;
    }
    if (!TalentInfoInfoDlg.validateIsEdit())
        return;
    var operation = function () {
        TalentInfoInfoDlg.clearData();
        TalentInfoInfoDlg.collectData();
        /*if (!TalentInfoInfoDlg.validate()) {
         return;
         }*/
        var id = $('#id').val();
        if (id != null && id != '') {
            if (!TalentInfoInfoDlg.validateIsEdit())
                return;
        }
        $("select,input[type=radio]").each(function () {
            $(this).removeAttr("disabled");
        });
        if (locked) {
            return;
        }
        locked = true;
        $("#talentInfoForm").attr("action", "/enterprise/talent/submitToCheck");
        $("#talentInfoForm")[0].submit();


        return;
        var ajax = new $ax(Feng.ctxPath + "/enterprise/talent/submit", function (data) {
            if (data.code == 200) {
                Feng.success(data.msg);
                // $("#checkState").val(data.obj);
                window.parent.TalentInfo.table.refresh();
                TalentInfoInfoDlg.close();
            } else {
                Feng.error(data.msg);
            }
        }, function (data) {
            Feng.error("提交审核失败!" + data.responseJSON.message + "!");
        });
        ajax.set("id", id);
        ajax.start();
    }
    Feng.confirm("请确认基础信息已核对无误，相应附件已上传，一旦提交，无法修改", operation);
}
//回调
TalentInfoInfoDlg.submitCallback = function (data) {
    locked = false;
    TalentInfoInfoDlg.setNoChangeField();
    if (data.code == 200) {
        Feng.success(data.msg);
        // $("#checkState").val(data.obj);
        window.parent.TalentInfo.table.refresh();
        TalentInfoInfoDlg.close();
    } else {
        Feng.error(data.msg);
    }
}

/**
 * 校验是否可以修改/提交审核
 */
TalentInfoInfoDlg.validateIsEdit = function () {    
    var checkState = $("#checkState").val();
    if (checkState != 0 && checkState != 8 && checkState != 1) {
        if (checkState == 16 || checkState == -1 || checkState == -2 || checkState == 7) {
            Feng.error("您的申报审核不通过，无法再修改");
            return false;
        } else if (checkState == 28) {
            Feng.error("申报已完成");
            return false;
        } else if (checkState == 14) {
            Feng.error("您的申报已审核通过，无法再修改");
            return false;
        } else if (checkState == 22 || checkState == 25 || checkState == 27) {
            Feng.error("该申报已终止");
            return false;
        } else {
            Feng.error("您的申报正在审核中，请耐心等待");
            return false;
        }
    }
    return true;
}

/**
 * 校验是否显示按钮
 * @param type      类型  1-上传按钮，2-修改删除按钮
 * @param row
 * @returns {string}
 */
TalentInfoInfoDlg.validUploadButton = function (type, fileTypeId, fileId, tableIndex, trIndex, isConditionFile) {
    var files = $("#files").val();
    var fields = $("#fields").val();
    files = files.split(",");
    fields = fields.split(",");
    var checkState = $("#checkState").val();
    var realState = $("#realState").val();
    //console.log(checkState, realState);
    var isConditionEditable = false;
    if (isConditionFile && (fields.indexOf("isMatchZhiren") != -1 || fields.indexOf("source") != -1 || fields.indexOf("talent_arrange") != -1 || fields.indexOf("talent_arrange_category") != -1 || fields.indexOf("talent_condition") != -1)) {
        isConditionEditable = true;
    }
    //if (Feng.isEmptyStr(checkState) || checkState == 0 || (checkState == 8 && realState == "") || (checkState == 8 && realState == 8) || (checkState == 11 && realState != 14) || (realState == 11 && (files.indexOf(fileTypeId.toString()) != -1 || isConditionEditable))) {
    if (Feng.isEmptyStr(checkState) || checkState == 0 || (checkState == 1 && (Feng.isEmptyStr(realState) || realState == 1)) || (checkState == 8 && (realState == 8 || Feng.isEmptyStr(realState))) || (checkState == 11 && realState != 14) || ((realState == 11 || realState == 4) && (files.indexOf(fileTypeId.toString()) != -1 || isConditionEditable))) {    
        if (type == 1) {          //上传
            return "<button type='button' onclick=\"TalentInfoInfoDlg.checkFile(this," + fileTypeId + "," + null + "," + tableIndex + "," + trIndex + ")\" style='margin-right: 10px' class=\"btn btn-xs btn-info\">" +
                    "<i class=\"fa fa-upload\"></i>上传" +
                    "</button>";
        } else {
            return "<button type=\'button\' onclick=\"TalentInfoInfoDlg.checkFile(this," + fileTypeId + "," + fileId + "," + tableIndex + "," + trIndex + ")\" style=\'margin-right: 10px\' class=\"btn btn-xs btn-info\">" +
                    "<i class=\"fa fa-paste\"></i>修改" +
                    "</button>" +
                    "<button type='button' onclick=\"TalentInfoInfoDlg.deleteFile(" + fileId + ",this)\" class=\"btn btn-xs btn-danger\">" +
                    "<i class=\"fa fa-times\"></i>删除" +
                    "</button>";
        }
    } else {
        return "";
    }
}


//回调
TalentInfoInfoDlg.callBack = function (data) {
    layer.close(data.obj);
    Feng.info(data.msg);
    if (data.code == 200) {
        var tableIndex = $("#tableIndex").val();
        var trIndex = $("#trIndex").val();
        var sn = data.info.lastIndexOf(".");
        var suffix = data.ext;//data.info.substring(sn + 1, data.info.length);
        var imgStr = "";
        if (suffix == "pdf" || suffix == "PDF") {
            imgStr = "<button type='button'  onclick=\"Feng.showPdf('" + data.info + "','" + data.id + "','" + data.orignName + "')\" class=\"btn btn-xs btn-danger\"><i class=\"fa fa-file-pdf-o\" aria-hidden=\"true\"></i></button>";
        } else if (suffix == "xlsx" || suffix == "XLSX" || suffix == 'xls' || suffix == 'XLS' || suffix == 'docx' || suffix == 'doc' || suffix == 'DOCX' || suffix == 'DOC') {
            imgStr = "<button type='button'  onclick=\"Feng.showExcel('" + data.info + "','" + data.id + "','" + data.orignName + "')\" class=\"btn btn-xs btn-danger\"><i class=\"fa fa-file-excel-o\" aria-hidden=\"true\"></i></button>";
        } else {
            imgStr = '<img class="imgUrl"  src="' + data.info + '" style="width:25px;height:25px;">';
        }
        var li = $("input[name='uploadFiles[]'][value='" + data.id + "'").parents("li");
        if (li.length > 0) {
            li.find("div").eq(1).html(data.orignName);
            li.find("div").eq(2).html(imgStr);
        } else {
            var html = '<li data-id="' + data.id + '">\n\
<div><input type="hidden" name="uploadFiles[]" value="' + data.id + '"></div>\n\
<div style="width: 70%;">' + data.orignName + '</div>\n\
<div style="width: 10%;">' + imgStr + '</div>\n\
<div style="width: 20%;">\n\
<button type="button" onclick="TalentInfoInfoDlg.checkFile(this,' + data.typeId + ',' + data.id + ',' + tableIndex + ',' + trIndex + ')" style="margin-right: 10px" class="btn btn-xs btn-info"><i class="fa fa-paste"></i>修改</button>\n\
<button type="button" onclick="TalentInfoInfoDlg.deleteFile(' + data.id + ',this)" class="btn btn-xs btn-danger"><i class="fa fa-times"></i>删除</button>\n\
</div></li></ul>';
            $(".fileTable").eq(tableIndex).find("tr[data-index='" + trIndex + "']").next("tr.detail-view").find(".imgs").append(html);
        }
    }
}
TalentInfoInfoDlg.downloadFile = function (id, type) {
    window.location.href = Feng.ctxPath + "/common/api/downloadFile?id=" + id + "&type=" + type;
}

//设置不可修改的字段
TalentInfoInfoDlg.setNoChangeField = function () {
    var checkState = $("#checkState").val();
    var fields = $("#fields").val();
    var realState = $("#realState").val();
    if (realState == 11 || realState == 4) {
        $("#photoImg").removeAttr("onclick");
        $("input,textarea").each(function () {
            $(this).attr("readonly", "readonly").css("pointer-events", "none");
        });
        $("select,input[type=radio]").each(function () {
            $(this).attr("disabled", "disabled");
        });
        if (fields != null && fields != '') {
            var arr = fields.split(",");
            for (var key in arr) {
                if (arr[key] == "headimgurl") {
                    $("#photoImg").bind("click", function () {
                        $("#photo").click();
                    });
                    continue;
                }
                if (arr[key] != "") {
                    var name = $("#" + arr[key]).prop("tagName");
                    if (name == 'select' || name == 'SELECT') {
                        $("#" + arr[key]).removeAttr("disabled");
                    } else if (name == "input" || name == 'textarea' || name == "INPUT" || name == 'TEXTAREA') {
                        $("#" + arr[key]).removeAttr("readonly").css("pointer-events", "initial");
                    } else {
                        if (typeof name == "undefined") {
                            $("input[name=" + arr[key] + "]").removeAttr("disabled").removeAttr("readonly").css("pointer-events", "initial");
                        }
                    }
                }
            }
        }
    }
}

TalentInfoInfoDlg.switchDateAndRangeDate = function (id) {
    var $obj = $("#" + id);
    var $prev = $obj.prev();
    var range = false;
    if ($obj.hasClass("date")) {
        range = true;
        $prev.find("a").html("切换无固定期限模式");
    } else {
        range = false;
        $prev.find("a").html("切换日期范围模式");
    }
    $obj.remove();
    $prev.after('<input type="text" class="form-control ' + (range ? "rangedate" : "date") + '" id="labor_contract_rangetime" name="labor_contract_rangetime" value="" />');
    laydate.render({
        elem: "#" + id,
        type: "date",
        range: range,
        trigger: "click"
    })
}

/**
 * 是否导入
 * @returns {Boolean}
 */
TalentInfoInfoDlg.isImport = function () {
    var isImport = parseInt($("#import").val());
    return isImport > 0 ? true : false;
}
/**
 * 是否直认
 * @returns {Boolean}
 */
TalentInfoInfoDlg.isZhiRen = function () {
    var isMatchZhiren = $("input[name=isMatchZhiren]").length > 0 && $("input[name=isMatchZhiren]:checked").val() == 1 ? true : false;
    return isMatchZhiren;
}

$("#card_type").change(function () {
    async_padding($("#card_number").val().trim(), $(this).val());
})
$("#card_number").blur(function () {
    var idCard = $(this).val();
    var ajax = new $ax(Feng.ctxPath + "/enterprise/talent/getTalentInfoFromOldLibrary", function (data) {
        if (data.code == 200) {
            var operation = function () {
                var info = data.info;
                $("#name").val(info.name);
                $("#card_type").val(info.cardType);
                $("#sex").val(info.sex);
                $("#birthday").val(info.birthday);
                $("#nation").val(info.nation);
                $("#politics").val(info.politics);
                $("#highest_degree").val(info.highEducation);
                $("#graduate_school").val(info.graduateSchool);
                $("#major").val(info.major);
                $("#study_abroad").val(info.studyAbroad);
                $("#phone").val(info.phone);
                $("#email").val(info.email);
                $("#position").val(info.post);
                $("#cur_entry_time").val(info.entryTime);
                $("#labor_contract_rangetime").val(info.startTime + " - " + info.endTime);
                $("#title").val(info.title);
                $("#talent_arrange").val(info.talentArrange);
                $("#bank").val(info.bank);
                $("#bank_number").val(info.bankNumber);
                $("#bank_branch_name").val(info.bankNetwork);
                $("#bank_account").val(info.bankAccount);
                $("#experience").val(info.mainHonours);
                $("#education").val(info.educationAndResume);
                TalentInfoInfoDlg.changeStudyAbroad();
                TalentInfoInfoDlg.getIdentifyCondition();
                TalentInfoInfoDlg.bankChange();
            }
            Feng.confirm("查询到信息库中存在该人员的信息，是否自动填入?", operation);
        } else {
            async_padding(idCard, $("#card_type").val());
        }
    }, function (data) {
    });
    ajax.set("idCard", idCard);
    ajax.start();
})
function async_padding(card_number, card_type) {
    if (card_number != "" && card_number.length == 18 && card_type == "1") {
        var year = card_number.substring(6, 10);
        var month = card_number.substring(10, 12);
        var day = card_number.substring(12, 14);
        var birthday = year + "-" + month + "-" + day;
        var rule = /\d{4}-\d{2}-\d{2}/;
        if (rule.test(birthday))
            $("#birthday").val(birthday);
        var num = card_number.substring(17, 1);
        if (num % 2 == 0) {
            $("#sex").val(2);
        } else {
            $("#sex").val(1);
        }
    }
}
$(function () {
    $('#talentInfoForm').bootstrapValidator({
        feedbackIcons: {
            valid: 'glyphicon glyphicon-ok',
            invalid: 'glyphicon glyphicon-remove',
            validating: 'glyphicon glyphicon-refresh'
        },
        container: 'tooltip',
        group: '.rowGroup',
        fields: TalentInfoInfoDlg.validateFields1,
        live: 'enabled',
        message: '该字段不能为空'
    }).on('error.field.bv', function (e, data) {
        // Get the tooltip
        var $parent = data.element.parents('#talentInfoForm'),
                $icon = $parent.find('.form-control-feedback[data-bv-icon-for="' + data.field + '"]'),
                title = $icon.data('bs.tooltip').getTitle();
        $icon.tooltip('destroy').tooltip({
            html: true,
            placement: 'right',
            title: title,
            container: 'body'
        });
    });

    var id = $("#id").val();
    var checkState = $("#checkState").val();
    //批量加载字典表数据
    var arr = [
        {"name": "nation", "code": "nation"},
        {"name": "talent_arrange", "code": "talent_arrange"},
        {"name": "nationality", "code": "nationality"},
        {"name": "politics", "code": "politics"},
        {"name": "highest_degree", "code": "highest_degree"}];
    Feng.findChildDictBatch(JSON.stringify(arr));

    //批量加载时间控件
    $(".date").each(function () {
        laydate.render({
            elem: this
            , type: 'date'
            , trigger: 'click'
        });
    });
    $(".rangedate").each(function () {
        laydate.render({
            elem: this,
            type: "date",
            range: true,
            trigger: "click"
        })
    })
    $(".rangemonth").each(function () {
        laydate.render({
            elem: this,
            type: "month",
            range: true,
            trigger: "click"
        })
    })
    if (id != null && id != '') {
        //select初始化
        $("select").each(function () {
            $(this).val($(this).attr("value")).trigger("change");
        });
        Feng.getCheckLog("logTable", {"type": CONFIG.project_rcrd, "mainId": id, "typeFileId": "", "active": 1})
    }
    TalentInfoInfoDlg.validId();
    $("#photo").change(function (e) {
        var tag = e.target;
        var file = tag.files[0];
        var imgSrc;
        var reader = new FileReader();
        reader.readAsDataURL(file);
        reader.onload = function () {
            imgSrc = this.result;
            $("#photoImg").attr("src", imgSrc);
        };
    });
    TalentInfoInfoDlg.setNoChangeField();
    $("#talent_condition").on('chosen:ready', function (e, params) {
        $(".chosen-container-single .chosen-single").css("padding", "4px 0px 0px 4px");
    });
    $("#talent_condition").val($("#talent_condition").attr("value"));
    $("#talent_condition").chosen({
        search_contains: true,       //关键字模糊搜索。设置为true，只要选项包含搜索词就会显示；设置为false，则要求从选项开头开始匹配
        disable_search: false,
        width: "100%",
        enable_split_word_search: true,
        rtl: true,
        classes: "test"
    });
    TalentInfoInfoDlg.initFileTable();
    TalentInfoInfoDlg.changeStudyAbroad();
    TalentInfoInfoDlg.initBirthday();
});


